=begin
#Golden Service API

#An API that conforms to the standards and best practices that should be adhered to in all Mastercard owned APIs. Can be used to create subscriptions to reports that are generated twice daily (6am & 6pm) that deliver e-commerce spending across multiple sectors and locations. <br/> --- * **All requests must be signed using oauth 1.0a. Please refer to: https://developer.mastercard.com/platform/documentation/using-oauth-1a-to-access-mastercard-apis/** --- * **The user must provide their card details when creating a subscription. These details must be encrypted before entering transit. Please refer to [Mastercard security](https://stage.developer.mastercard.com/platform/documentation/securing-sensitive-data-using-payload-encryption/)** --- 

The version of the OpenAPI document: 1.1.0
Contact: developers@mastercard.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.0.1-SNAPSHOT

=end

# Common files
require 'openapi_client/api_client'
require 'openapi_client/api_error'
require 'openapi_client/version'
require 'openapi_client/configuration'

# Models
require 'openapi_client/models/active_subscription'
require 'openapi_client/models/error'
require 'openapi_client/models/error_errors'
require 'openapi_client/models/error_errors_error'
require 'openapi_client/models/sector'
require 'openapi_client/models/sector_spending'
require 'openapi_client/models/spending_report'
require 'openapi_client/models/subscription'
require 'openapi_client/models/subscription_object'
require 'openapi_client/models/subscription_payment_card'
require 'openapi_client/models/subscription_response'
require 'openapi_client/models/top_locations_report'
require 'openapi_client/models/unsubscribed_response'

# APIs
require 'openapi_client/api/reports_api'
require 'openapi_client/api/sector_api'
require 'openapi_client/api/subscribe_api'

module OpenapiClient
  class << self
    # Customize default settings for the SDK using block.
    #   OpenapiClient.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
